#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
main()
{
   Display *d;  Window r, w;
   Atom a1, a2, a3, type;
   int format, *data, i;
   unsigned long nitems, left;
   char *text;
   d = XOpenDisplay (NULL);
   r = RootWindow (d, 0);

   a1 = XInternAtom (d, "My String", False);
   a2 = XInternAtom (d, "My Integer", False);
   a3 = XInternAtom (d, "My Window", False);

   XGetWindowProperty (d, r, a1, 0, 20, False, XA_STRING,
                       &type, &format, &nitems, &left, &text);
   printf ("My String: %s\n", text);

   XGetWindowProperty (d, r, a2, 3, 2, False, XA_INTEGER,
                       &type, &format, &nitems, &left, &data);
   for (i = 0; i < nitems; i++)
     printf ("My Integer [%d] = %d\n", i, data[i]);

   XGetWindowProperty (d, r, a3, 0, 1, False, XA_WINDOW,
                       &type, &format, &nitems, &left, &w);
   printf ("My Window: %d\n", w);
}
