#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
main()
{
   Display *d;
   Window w;
   Atom a[3], *list, type;
   static char *p[] = { "Prop0", "Prop1", "Prop2" };
   static char *s[] = { "Text0", "Text1", "Text2" };
   unsigned long nitems, left;
   char *text;
   int format, i, n;

   d = XOpenDisplay (NULL);
   w = XCreateSimpleWindow (d, RootWindow (d, 0), 200, 200,
                            100, 100, 2, 0, 1);

   for (i = 0; i < 3; i++)
     {
       a[i] = XInternAtom (d, p[i], False);
       XChangeProperty (d, w, a[i], XA_STRING, 8,
                        PropModeReplace, s[i], 5);
     }

   XRotateWindowProperties (d, w, a, 3, 1);

   for (i = 0; i < 3; i++)
     {
       XGetWindowProperty (d, w, a[i], 0, 20, False, XA_STRING,
                           &type, &format, &nitems, &left, &text);
       printf ("Property = %s, data = %s\n", p[i], text);
     }

   XDeleteProperty (d, w, a[1]);

   list = XListProperties (d, w, &n);
   for (i = 0; i < n; i++)
     printf ("List Property %d: %s\n", i, XGetAtomName (d, list[i]));
}
